# Import server module
import time
import http.server
# Import SocketServer module
import socketserver

def start_server(port=8000):
    # Create object for handling HTTP requests
    handler = http.server.SimpleHTTPRequestHandler
    # Run the server forever to handle the HTTP requests
    with socketserver.TCPServer(("", port), handler) as httpd:
        print("Web Server is running at http://localhost:%s" % port)
        print("Patient list can be accessed  at http://localhost:%s/web/PatientFlags.html" % port)
        httpd.serve_forever()


def update_function(patient_list):
    while True:
        update_html_file(patient_list=patient_list)
        time.sleep(0.5)


def html_patient(patient):
    html_str = "  <tr>\n" \
               "    <td>{0}</td>\n" \
               "    <td>" \
               "      <p style=\"color:{1};\">" \
               "      {1}\n" \
               "      </p>" \
               "    </td>" \
               "    <td>{2}</td>\n" \
               "  </tr>\n".format(patient["last_name"] + ' ' + patient["first_name"],
                                  patient["Patient_Priority"],
                                  int(time.time()-patient["entrance"]))
    return html_str


def html_patient_list(patient_list):
    html_str = "<b>Patient List</b>"
    html_str += "<table>\n" \
                "  <tr>\n" \
                "    <th>Patient</th>\n" \
                "    <th>Flag</th>\n" \
                "    <th>Wait Time [s]</th>\n" \
                "  </tr>\n"
    for elem in patient_list:
        html_str += html_patient(elem)
    html_str += "</table>\n"
    return html_str


def html_header():
    html_str = "  <head>\n" \
               "    <meta http-equiv=\"refresh\" content=\"10\" />" \
               "    <title>\n" \
               "        Patients and their flags\n" \
               "    </title>\n" \
               "  </head>\n"
    return html_str


def build_html(patient_list):
    html_str = "<html lang=\"GER\">\n"
    html_str += html_header()
    html_str += "<body style=\"background-color:grey\">\n"
    html_str += html_patient_list(patient_list)
    html_str += "</body>\n"
    html_str += "</html>\n"
    return html_str


def update_html_file(patient_list):
    table_file = open('web/PatientFlags.html', 'w')
    table_file.write(build_html(patient_list))
    table_file.close()
