import json
import os
from copy import deepcopy

response = {
  "resourceType": "QuestionnaireResponse",
  "id": "e6f93635-cbd6-468b-9fb6-1fabde7b879a",
  "contained":
  [
    {
      "resourceType": "Patient",
      "id": "4ae96da4-e763-43b6-bced-cac45d6949db",
      "identifier":
      [
        {
          "type":
        {
          "text": "Patient Number"
        },
          "value": "0"
        },
        {
          "type":
        {
          "text": "Case Number"
        },
          "value": "0"
        }
      ],
      "name":
      [
        {
          "family": "Tepes",
          "given":
          [
            "Krul"
          ]
        }
      ],
      "gender": "female",
      "birthDate": "1900-01-01",
      "address":
      [
        {
          "text": "Musterstr"
        }
      ]
    }
  ],
  "identifier":
  {
    "type":
  {
    "text": "Questionnaire Id"
  },
    "value": "087445ac-56e2-438b-9aa3-f144d7114307"
  },
  "status": "completed",
  "authored": "2022-01-20T12:58:21.776000+00:00",
  "source":
  {
    "reference": "#4ae96da4-e763-43b6-bced-cac45d6949db"
  },
  "item":
  [
    {
    "linkId": "1",
    "text": "Wegen welcher der folgenden Beschwerden haben Sie heute die Notaufnahme aufgesucht oder wurden von einem Arzt in die Notaufnahme geschickt (Bei Vorhandensein mehrerer Beschwerden kreuzen Sie bitte diejenige an, die im Vordergrund steht und zur Vorstellung hier Anlass gegeben hat.): ",
    "answer":
    [
      {
        "valueString": "Schwindel"
      }
    ]
    },
  ]
}

def f(x):
  return x.split("-")[-1].split(".")[0]

with open("questionnaire") as file:
  questionnaire = json.load(file)

files_already_created = list(map(f, os.listdir("unprocessed_files")))
files_already_created.sort(key = lambda i: int(i, 16))
last_patient_id = "e6f93635-cbd6-468b-9fb6-" + files_already_created[-1]
patient_name = " " # placeholder
while patient_name != "":
  response["item"] = []
  patient_name = input("Patient Name: ")
  if " " in patient_name:
    first_name = patient_name.split(" ")[1]
    last_name = patient_name.split(" ")[0]
  else:
    first_name = patient_name
    last_name = ""
  response["id"] = "-".join(last_patient_id.split("-")[:-1]) + "-" + hex(int(last_patient_id.split("-")[-1],16)+1)[2:] # counts the last hexadecimal one up
  last_patient_id = deepcopy(response["id"])
  print(f"ID: {last_patient_id}")
  response["contained"][0]["name"] = [
                                      {
                                      "family": first_name,
                                      "given":
                                      [
                                          last_name
                                      ]
                                      }
                                  ]
  for question in questionnaire["item"]:
    question_processed = {"linkId": question["linkId"], "text": question["text"], "answer": []}
    print(question["text"])
    print("Answers: ")
    for idx, answer in enumerate(question["answer"]):
      print(str(idx+1)+": "+answer["valueString"])

    if int(question["multipleAnswers"]):
      input_answer = " " # placeholder
      print("choose by number untill done, then press enter")
      while input_answer != "":
        input_answer = input("> ")
        if input_answer != "":
          try:
            input_answer = int(input_answer)
          except Exception:
            input_answer = -1
          if input_answer-1 in range(len(question["answer"])):
            question_processed["answer"].append(question["answer"][input_answer-1])
          else:
            print("Invalid")
    else:
      input_answer = -1
      while input_answer-1 not in range(len(question["answer"])):
        print("choose an answer by number")
        input_answer = input("> ")
        try:
          input_answer = int(input_answer)
        except Exception:
          input_answer = -1
      question_processed["answer"].append(question["answer"][input_answer-1])
    response["item"].append(question_processed)

  
  os.system("touch unprocessed_files/"+last_patient_id+".json")
  with open("unprocessed_files/"+last_patient_id+".json", "w") as file:
    json.dump(response, file)
    
